public class InsertionSortTest
{

	public static void insertionSort(double[] data)
	{
		for (int i=1; i<data.length; i++)
		{
		    double temp = data[i]; // value to be inserted into
		                           // "left side" of array
		    int j;

		    // Find the insertion point
		    // This part can be improved by applying the binary search
		    for (j = 0; j < i; j++)
		    	if (data[j] > data[i])
		    		break;

		    // Shuffle up the array
		    if (j < i)
		   		for (int k = i - 1; k >= j; k--)
		   			data[k+1] = data[k];
		   	data[j] = temp;

		}
    }


    public static void main(String[] args)
    {
		double[] data = {5.0, 0.0, -2.3, -0.3, -7.0, 1.2};

		System.out.println("Data array: ");
		print_array(data);

		insertionSort(data);

		System.out.println("Sorted data array");
		print_array(data);

    }

    public static void print_array(double[] d)
    {
		for (int i=0; i < d.length; i++)
			System.out.print(d[i] + " ");
		System.out.println();
	}
}